# -*- coding: utf-8 -*-
#
############################################################################
#
# (c) 2006-2007 Florian Birée aka Thesa <florian@biree.name> 
# (c) 2006 Achraf Cherti aka Asher256 <achrafcherti@gmail.com>
#
# Website: <URL:http://casetta.tuxfamily.org>
# 
# Version 0.3.0
#
# changelog:
#
# # version 0.2.0:
#
# o first version (version number aligned on casetta_gtk)
#
############################################################################
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 
# 02110-1301, USA.
#
# http://www.gnu.org/copyleft/gpl.html
#
############################################################################
"""Fill the equiv list in two way"""

__author__ = "Florian Birée, Achraf Cherti"
__version__ = "0.3.0"
__license__ = "GPL"
__copyright__ = "Copyright (c) 2006-2007, Florian Birée, Achraf Cherti"
__revision__ = "$Revision: $"
# $Source: $
__date__ = "$Date: $"

# i18n
application = 'gasetta'
_ = lambda text:text

# Imports
from casetta import catdic

# Function
def make_prgm_command_list():
    """Return the list of command list"""
    clist = ['\\->', '\\If ', '\\Then ', '\\Else ', '\\IfEnd', '\\For ', \
             '\\ To ', '\\ Step ', '\\Next', '\\While ', '\\WhileEnd', \
             '\\Do', '\\LpWhile ', 'CTL', '\\Prog ', '\\Return', '\\Break', \
             '\\Stop', '\\Lbl ', '\\Goto ', '\\=>', '\\Isz ', '\\Dsz ', '?', \
             '\\Disp\n', '\\ClrText', '\\ClrGraph', '\\ClrList', '\\DrawStat', \
             '\\DrawGraph', '\\DrawDyna', '\\DispF-Tbl', '\\DrawFTG-Con', \
             '\\DrawFTG-Plt', 'R-Tbl', '\\DispR-Tbl', '\\DrawWeb ', \
             '\\DrawR-Con', '\\DrawR-SumCon', '\\DrawR-Plt', \
             '\\DrawR-SumPlt', '=', '<>', '>', '<', '>=', '<=', 'I/O', \
             '\\Locate ', '\\Getkey', '\\Send(', '\\Receive(']
    return clist
    
def make_equiv_list():
    """Return the list of equivalences"""
    elist = []
    for key in catdic.r2c:
        elist.append(catdic.r2c[key][0])
    for key in catdic.r2n:
        elist.append(catdic.r2n[key][0])
    elist.append('\\aster')
    elist.append('\\slash')
    elist.remove('\\Disp' + chr(13))
    elist.append('\\Disp' + chr(10))
    return elist
    
def plane(tree_store):
    """Fill the equiv list with a plane list"""
    tree_store.clear()
    elist = make_equiv_list()
    elist.sort()
    for equiv in elist:
        tree_store.append(None, [equiv])

def casio(tree_store):
    """Fill the equiv list as the casio organisation"""
    tree_store.clear()
    # keyboard
    keyboard = tree_store.append(None, ['Keyboard'])
    tree_store.append(keyboard, ['\\x^2'])
    tree_store.append(keyboard, ['\\sqrt'])
    tree_store.append(keyboard, ['\\(r)'])
    tree_store.append(keyboard, ['^'])
    tree_store.append(keyboard, ['\\xrt'])
    tree_store.append(keyboard, ['\\theta'])
    tree_store.append(keyboard, ['A'])
    tree_store.append(keyboard, ['\\log '])
    tree_store.append(keyboard, ['\\10^x'])
    tree_store.append(keyboard, ['B'])
    tree_store.append(keyboard, ['\\ln '])
    tree_store.append(keyboard, ['\\e^x'])
    tree_store.append(keyboard, ['C'])
    tree_store.append(keyboard, ['\\sin '])
    tree_store.append(keyboard, ['\\asin '])
    tree_store.append(keyboard, ['D'])
    tree_store.append(keyboard, ['\\cos '])
    tree_store.append(keyboard, ['\\acos '])
    tree_store.append(keyboard, ['E'])
    tree_store.append(keyboard, ['\\tan '])
    tree_store.append(keyboard, ['\\atan '])
    tree_store.append(keyboard, ['F'])
    tree_store.append(keyboard, ['\\ab/c'])
    tree_store.append(keyboard, ['G'])
    tree_store.append(keyboard, ['H'])
    tree_store.append(keyboard, ['('])
    tree_store.append(keyboard, ['\\curt'])
    tree_store.append(keyboard, ['I'])
    tree_store.append(keyboard, ['])'])
    tree_store.append(keyboard, ['\\x^-1'])
    tree_store.append(keyboard, ['J'])
    tree_store.append(keyboard, [','])
    tree_store.append(keyboard, ['K'])
    tree_store.append(keyboard, ['\\->'])
    tree_store.append(keyboard, ['L'])
    tree_store.append(keyboard, ['7'])
    tree_store.append(keyboard, ['M'])
    tree_store.append(keyboard, ['8'])
    tree_store.append(keyboard, ['N'])
    tree_store.append(keyboard, ['9'])
    tree_store.append(keyboard, ['O'])
    tree_store.append(keyboard, ['4'])
    tree_store.append(keyboard, ['P'])
    tree_store.append(keyboard, ['5'])
    tree_store.append(keyboard, ['Q'])
    tree_store.append(keyboard, ['6'])
    tree_store.append(keyboard, ['R'])
    tree_store.append(keyboard, ['*'])
    tree_store.append(keyboard, ['{'])
    tree_store.append(keyboard, ['S'])
    tree_store.append(keyboard, ['/'])
    tree_store.append(keyboard, ['}'])
    tree_store.append(keyboard, ['T'])
    tree_store.append(keyboard, ['1'])
    tree_store.append(keyboard, ['U'])
    tree_store.append(keyboard, ['2'])
    tree_store.append(keyboard, ['V'])
    tree_store.append(keyboard, ['3'])
    tree_store.append(keyboard, ['W'])
    tree_store.append(keyboard, ['+'])
    tree_store.append(keyboard, ['['])
    tree_store.append(keyboard, ['X'])
    tree_store.append(keyboard, ['-'])
    tree_store.append(keyboard, [']'])
    tree_store.append(keyboard, ['Y'])
    tree_store.append(keyboard, ['0'])
    tree_store.append(keyboard, ['Z'])
    tree_store.append(keyboard, ['.'])
    tree_store.append(keyboard, ['='])
    tree_store.append(keyboard, [' '])
    tree_store.append(keyboard, ['\\E'])
    tree_store.append(keyboard, ['\\Pi'])
    tree_store.append(keyboard, ['\\(-)'])
    tree_store.append(keyboard, ['\\Ans'])
    # shift
    shift = tree_store.append(None, ['[SHIFT]'])
    zoom = tree_store.append(shift, ['ZOOM'])
    tree_store.append(zoom, ['\\Factor '])
    vwin = tree_store.append(shift, ['V-WIN'])
    tree_store.append(vwin, ['\\ViewWindow '])
    tree_store.append(vwin, ['\\StoV-Win '])
    tree_store.append(vwin, ['\\RclV-Win '])
    sktch = tree_store.append(shift, ['SKTCH'])
    tree_store.append(sktch, ['\\Cls'])
    tree_store.append(sktch, ['\\Tangent '])
    tree_store.append(sktch, ['\\Normal '])
    tree_store.append(sktch, ['\\Inverse '])
    grph = tree_store.append(sktch, ['GRPH'])
    tree_store.append(grph, ['\\Graph Y='])
    tree_store.append(grph, ['\\Graph r='])
    tree_store.append(grph, ['\\Graph (X,Y)=('])
    tree_store.append(grph, ['\\Graph X='])
    tree_store.append(grph, ['\\Graph Integral '])
    tree_store.append(grph, ['\\Graph Y>'])
    tree_store.append(grph, ['\\Graph Y<'])
    tree_store.append(grph, ['\\Graph Y>='])
    tree_store.append(grph, ['\\Graph Y<='])
    plot = tree_store.append(sktch, ['PLOT'])
    tree_store.append(plot, ['\\Plot '])
    tree_store.append(plot, ['\\PlotOn '])
    tree_store.append(plot, ['\\PlotOff '])
    tree_store.append(plot, ['\\PlotChg '])
    line = tree_store.append(sktch, ['LINE'])
    tree_store.append(line, ['\\Line'])
    tree_store.append(line, ['\\F-Line '])
    tree_store.append(sktch, ['\\Circle '])
    tree_store.append(sktch, ['\\Vertical '])
    tree_store.append(sktch, ['\\Horizontal '])
    tree_store.append(sktch, ['\\Text '])
    pixl = tree_store.append(sktch, ['PIXL'])
    tree_store.append(pixl, ['\\PxlOn '])
    tree_store.append(pixl, ['\\PxlOff '])
    tree_store.append(pixl, ['\\PxlChg '])
    tree_store.append(sktch, ['\\PxlTest '])
    # alpha/sybl
    sybl = tree_store.append(None, ['[ALPHA]/SYBL'])
    tree_store.append(sybl, ["'"])
    tree_store.append(sybl, ['"'])
    tree_store.append(sybl, ['~'])
    tree_store.append(sybl, ['\\aster'])
    tree_store.append(sybl, ['\\slash'])
    tree_store.append(sybl, ['#'])
    # menu
    menu = tree_store.append(None, ['MENU'])
    stat = tree_store.append(menu, ["STAT"])
    draw = tree_store.append(stat, ["DRAW"])
    tree_store.append(draw, ["\\DrawOn"])
    tree_store.append(draw, ["\\DrawOff"])
    grph = tree_store.append(stat, ["GRPH"])
    tree_store.append(grph, ["\\S-Gph1 "])
    tree_store.append(grph, ["\\S-Gph2 "])
    tree_store.append(grph, ["\\S-Gph3 "])
    tree_store.append(grph, ["\\Scatter"])
    tree_store.append(grph, ["\\xyLine"])
    tree_store.append(grph, ["\\Hist"])
    tree_store.append(grph, ["\\MedBox"])
    tree_store.append(grph, ["\\MeanBox"])
    tree_store.append(grph, ["\\N-Dist"])
    tree_store.append(grph, ["\\Broken"])
    tree_store.append(grph, ["\\Linear"])
    tree_store.append(grph, ["\\Med-Med"])
    tree_store.append(grph, ["\\Quad"])
    tree_store.append(grph, ["\\Cubic"])
    tree_store.append(grph, ["\\Quart"])
    tree_store.append(grph, ["\\Log"])
    tree_store.append(grph, ["\\Exp"])
    tree_store.append(grph, ["\\Power"])
    tree_store.append(grph, ["\\Sinusoidal"])
    tree_store.append(grph, ["\\NPPlot"])
    tree_store.append(grph, ["\\Logistic"])
    item_list = tree_store.append(stat, ["LIST"])
    tree_store.append(item_list, ["\\List1"])
    tree_store.append(item_list, ["\\List2"])
    tree_store.append(item_list, ["\\List3"])
    tree_store.append(item_list, ["\\List4"])
    tree_store.append(item_list, ["\\List5"])
    tree_store.append(item_list, ["\\List6"])
    mark = tree_store.append(stat, ["MARK"])
    tree_store.append(mark, ["\\Square"])
    tree_store.append(mark, ["\\Cross"])
    tree_store.append(mark, ["\\Dot"])
    colr = tree_store.append(stat, ["COLR"])
    tree_store.append(colr, ["\\Blue "])
    tree_store.append(colr, ["\\Orange "])
    tree_store.append(colr, ["\\Green "])
    calc = tree_store.append(stat, ["CALC"])
    tree_store.append(calc, ["\\1-Variable "])
    tree_store.append(calc, ["\\2-Variable "])
    tree_store.append(calc, ["\\LinearReg "])
    tree_store.append(calc, ["\\Med-MedLine "])
    tree_store.append(calc, ["\\QuadReg "])
    tree_store.append(calc, ["\\CubicReg "])
    tree_store.append(calc, ["\\QuartReg "])
    tree_store.append(calc, ["\\LogReg "])
    tree_store.append(calc, ["\\ExpReg "])
    tree_store.append(calc, ["\\PowerReg "])
    tree_store.append(calc, ["\\SinReg "])
    tree_store.append(calc, ["\\LogisticReg "])
    mat = tree_store.append(menu, ["MAT"])
    tree_store.append(mat, ["\\Swap("])
    tree_store.append(mat, ["\\*Row("])
    tree_store.append(mat, ["\\*Row+("])
    tree_store.append(mat, ["\\Row+("])
    item_list = tree_store.append(menu, ["LIST"])
    tree_store.append(item_list, ["\\SortA("])
    tree_store.append(item_list, ["\\SortD("])
    grph = tree_store.append(menu, ["GRPH"])
    sel = tree_store.append(grph, ["SEL"])
    tree_store.append(sel, ["\\G SelOn "])
    tree_store.append(sel, ["\\G SelOff "])
    item_type = tree_store.append(grph, ["TYPE"])
    tree_store.append(item_type, ["\\Y=Type"])
    tree_store.append(item_type, ["\\r=Type"])
    tree_store.append(item_type, ["\\ParamType"])
    tree_store.append(item_type, ["\\X=cType"])
    tree_store.append(item_type, ["\\Y>Type"])
    tree_store.append(item_type, ["\\Y<Type"])
    tree_store.append(item_type, ["\\Y>=Type"])
    tree_store.append(item_type, ["\\Y<=Type"])
    colr = tree_store.append(grph, ["COLR"])
    tree_store.append(colr, ["\\BlueG "])
    tree_store.append(colr, ["\\OrangeG "])
    tree_store.append(colr, ["\\GreenG "])
    gmem = tree_store.append(grph, ["GMEM"])
    tree_store.append(gmem, ["\\StoGMEM "])
    tree_store.append(gmem, ["\\RclGMEM "])
    dyna = tree_store.append(menu, ["DYNA"])
    tree_store.append(dyna, ["\\D SelOn "])
    tree_store.append(dyna, ["\\D SelOff "])
    tree_store.append(dyna, ["\\D Var "])
    item_type = tree_store.append(dyna, ["TYPE"])
    tree_store.append(item_type, ["\\Y=Type"])
    tree_store.append(item_type, ["\\r=Type"])
    tree_store.append(item_type, ["\\ParamType"])
    tabl = tree_store.append(menu, ["TABL"])
    tree_store.append(tabl, ["\\T SelOn "])
    tree_store.append(tabl, ["\\T SelOff "])
    item_type = tree_store.append(tabl, ["TYPE"])
    tree_store.append(item_type, ["\\Y=Type"])
    tree_store.append(item_type, ["\\r=Type"])
    tree_store.append(item_type, ["\\ParamType"])
    tree_store.append(tabl, ["\\BlueG "])
    tree_store.append(tabl, ["\\OrangeG "])
    tree_store.append(tabl, ["\\GreenG "])
    recr = tree_store.append(menu, ["RECR"])
    selc = tree_store.append(recr, ["SEL+C"])
    tree_store.append(selc, ["\\R SelOn "])
    tree_store.append(selc, ["\\R SelOff "])
    tree_store.append(selc, ["\\BlueG "])
    tree_store.append(selc, ["\\OrangeG "])
    tree_store.append(selc, ["\\GreenG "])
    item_type = tree_store.append(recr, ["TYPE"])
    tree_store.append(item_type, ["\\aRanType"])
    tree_store.append(item_type, ["a\\R n+Type"])
    tree_store.append(item_type, ["a\\R n+2Type"])
    # optn
    optn = tree_store.append(None, ['[OPTN]'])
    item_list = tree_store.append(optn, ['LIST'])
    tree_store.append(item_list, ['\\List '])
    tree_store.append(item_list, ['\\List->Mat('])
    tree_store.append(item_list, ['\\Dim '])
    tree_store.append(item_list, ['\\Fill('])
    tree_store.append(item_list, ['\\Seq('])
    tree_store.append(item_list, ['\\Min('])
    tree_store.append(item_list, ['\\Max('])
    tree_store.append(item_list, ['\\Mean('])
    tree_store.append(item_list, ['\\Median('])
    tree_store.append(item_list, ['\\Sum '])
    tree_store.append(item_list, ['\\Prod '])
    tree_store.append(item_list, ['\\Cuml '])
    tree_store.append(item_list, ['\\Percent '])
    tree_store.append(item_list, ['\\DeltaList '])
    mat = tree_store.append(optn, ['MAT'])
    tree_store.append(mat, ['\\Mat '])
    tree_store.append(mat, ['\\Mat->List('])
    tree_store.append(mat, ['\\Det '])
    tree_store.append(mat, ['\\Trn '])
    tree_store.append(mat, ['\\Augment('])
    tree_store.append(mat, ['\\Identity '])
    tree_store.append(mat, ['\\Dim '])
    tree_store.append(mat, ['\\Fill('])
    cplx = tree_store.append(optn, ['CPLX'])
    tree_store.append(cplx, ['\\{i}'])
    tree_store.append(cplx, ['\\Abs '])
    tree_store.append(cplx, ['\\Arg '])
    tree_store.append(cplx, ['\\Conj '])
    tree_store.append(cplx, ['\\ReP '])
    tree_store.append(cplx, ['\\ImP '])
    calc = tree_store.append(optn, ['CALC'])
    tree_store.append(calc, ['\\Solve('])
    tree_store.append(calc, ['\\d/dx('])
    tree_store.append(calc, ['\\d2/dxc('])
    tree_store.append(calc, ['\\Integral('])
    tree_store.append(calc, ['\\FMin('])
    tree_store.append(calc, ['\\FMax('])
    tree_store.append(calc, ['\\Sum('])
    stat = tree_store.append(optn, ['STAT'])
    tree_store.append(stat, ['\\Eox'])
    tree_store.append(stat, ['\\Eoy'])
    colr = tree_store.append(optn, ['COLR'])
    tree_store.append(colr, ['\\Orange '])
    tree_store.append(colr, ['\\Green '])
    hyp = tree_store.append(optn, ['HYP'])
    tree_store.append(hyp, ['\\sinh '])
    tree_store.append(hyp, ['\\cosh '])
    tree_store.append(hyp, ['\\tanh '])
    tree_store.append(hyp, ['\\asinh '])
    tree_store.append(hyp, ['\\acosh '])
    tree_store.append(hyp, ['\\atanh '])
    prob = tree_store.append(optn, ['PROB'])
    tree_store.append(prob, ['!'])
    tree_store.append(prob, ['\\nPr'])
    tree_store.append(prob, ['\\nCr'])
    tree_store.append(prob, ['\\Ran#'])
    tree_store.append(prob, ['\\ProbP('])
    num = tree_store.append(optn, ['NUM'])
    tree_store.append(num, ['\\Abs '])
    tree_store.append(num, ['\\Int '])
    tree_store.append(num, ['\\Frac '])
    tree_store.append(num, ['\\Rnd'])
    tree_store.append(num, ['\\Intg '])
    angl = tree_store.append(optn, ['ANGL'])
    tree_store.append(angl, ['\\Deg>'])
    tree_store.append(angl, ['\\Rad>'])
    tree_store.append(angl, ['\\Gra>'])
    tree_store.append(angl, ['\\Dms'])
    tree_store.append(angl, ['\\Deg>'])
    tree_store.append(angl, ['\\Pol('])
    tree_store.append(angl, ['\\Rec('])
    esym = tree_store.append(optn, ['ESYM'])
    tree_store.append(esym, ['\\milli'])
    tree_store.append(esym, ["\\micro"])
    tree_store.append(esym, ["\\nano"])
    tree_store.append(esym, ["\\pico"])
    tree_store.append(esym, ["\\fempto"])
    tree_store.append(esym, ["\\kilo"])
    tree_store.append(esym, ["\\Mega"])
    tree_store.append(esym, ["\\Giga"])
    tree_store.append(esym, ["\\Tera"])
    tree_store.append(esym, ["\\Peta"])
    tree_store.append(esym, ["\\Exa"])
    pict = tree_store.append(optn, ['PICT'])
    tree_store.append(pict, ['\\StoPict '])
    tree_store.append(pict, ['\\RclPict '])
    fmem = tree_store.append(optn, ['FMEM'])
    tree_store.append(fmem, ['\\f1'])
    tree_store.append(fmem, ['\\f2'])
    tree_store.append(fmem, ['\\f3'])
    tree_store.append(fmem, ['\\f4'])
    tree_store.append(fmem, ['\\f5'])
    tree_store.append(fmem, ['\\f6'])
    logic = tree_store.append(optn, ['LOGIC'])
    tree_store.append(logic, ['\\ And '])
    tree_store.append(logic, ['\\ Or '])
    tree_store.append(logic, ['\\Not '])
    # vars
    item_vars = tree_store.append(None, ['[VARS]'])
    vwin = tree_store.append(item_vars, ['V-WIN'])
    item_x = tree_store.append(vwin, ['X'])
    tree_store.append(item_x, ['\\Xmin'])
    tree_store.append(item_x, ['\\Xmax'])
    tree_store.append(item_x, ['\\Xscl'])
    item_y = tree_store.append(vwin, ['Y'])
    tree_store.append(item_y, ['\\Ymin'])
    tree_store.append(item_y, ['\\Ymax'])
    tree_store.append(item_y, ['\\Yscl'])
    item_t = tree_store.append(vwin, ['T,theta'])
    tree_store.append(item_t, ['\\Tmin'])
    tree_store.append(item_t, ['\\Tmax'])
    tree_store.append(item_t, ['\\Tptch'])
    right_x = tree_store.append(vwin, ['R-X'])
    tree_store.append(right_x, ['\\RightXmin'])
    tree_store.append(right_x, ['\\RightXmax'])
    tree_store.append(right_x, ['\\RightXscl'])
    right_y = tree_store.append(vwin, ['R-Y'])
    tree_store.append(right_y, ['\\RightYmin'])
    tree_store.append(right_y, ['\\RightYmax'])
    tree_store.append(right_y, ['\\RightYscl'])
    right_t = tree_store.append(vwin, ['R-T,theta'])
    tree_store.append(right_t, ['\\RightTmin'])
    tree_store.append(right_t, ['\\RightTmax'])
    tree_store.append(right_t, ['\\RightTptch'])
    fact = tree_store.append(item_vars, ['FACT'])
    tree_store.append(fact, ['\\Xfct'])
    tree_store.append(fact, ['\\Yfct'])
    stat = tree_store.append(item_vars, ['STAT'])
    item_x = tree_store.append(stat, ['X'])
    tree_store.append(item_x, ['\\Cnt'])
    tree_store.append(item_x, ['\\Meanx'])
    tree_store.append(item_x, ['\\Sumx'])
    tree_store.append(item_x, ['\\Sumx2'])
    tree_store.append(item_x, ['\\Sdx'])
    tree_store.append(item_x, ['\\Sdxn'])
    tree_store.append(item_x, ['\\minX'])
    tree_store.append(item_x, ['\\maxX'])
    item_y = tree_store.append(stat, ['Y'])
    tree_store.append(item_y, ['\\Meany'])
    tree_store.append(item_y, ['\\Sumy'])
    tree_store.append(item_y, ['\\Sumy2'])
    tree_store.append(item_y, ['\\Sumxy'])
    tree_store.append(item_y, ['\\Sdy'])
    tree_store.append(item_y, ['\\Sdyn'])
    tree_store.append(item_y, ['\\minY'])
    tree_store.append(item_y, ['\\maxY'])
    grph = tree_store.append(stat, ['GRPH'])
    tree_store.append(grph, ['\\{a}'])
    tree_store.append(grph, ['\\{b}'])
    tree_store.append(grph, ['\\{c}'])
    tree_store.append(grph, ['\\{d}'])
    tree_store.append(grph, ['\\{e}'])
    tree_store.append(grph, ['\\Cor'])
    tree_store.append(grph, ['\\Q1'])
    tree_store.append(grph, ['\\Med'])
    tree_store.append(grph, ['\\Q3'])
    tree_store.append(grph, ['\\Mo'])
    tree_store.append(grph, ['\\H Start'])
    tree_store.append(grph, ['\\H pitch'])
    pts = tree_store.append(stat, ['PTS'])
    tree_store.append(pts, ['\\x1'])
    tree_store.append(pts, ['\\y1'])
    tree_store.append(pts, ['\\x2'])
    tree_store.append(pts, ['\\y2'])
    tree_store.append(pts, ['\\x3'])
    tree_store.append(pts, ['\\y3'])
    test = tree_store.append(stat, ['TEST'])
    tree_store.append(test, ['\\Cnt'])
    tree_store.append(test, ['\\Meanx'])
    tree_store.append(test, ['\\Sdxn'])
    tree_store.append(test, ['\\n1'])
    tree_store.append(test, ['\\n2'])
    tree_store.append(test, ['\\Test x1'])
    tree_store.append(test, ['\\Test x2'])
    tree_store.append(test, ['\\x1on-1'])
    tree_store.append(test, ['\\x2on-1'])
    tree_store.append(test, ['\\xpon-1'])
    tree_store.append(test, ['\\{F}'])
    tree_store.append(test, ['\\Fdf'])
    tree_store.append(test, ['\\SS'])
    tree_store.append(test, ['\\MS'])
    tree_store.append(test, ['\\Edf'])
    tree_store.append(test, ['\\SSe'])
    tree_store.append(test, ['\\MSe'])
    reslt = tree_store.append(stat, ['RESLT'])
    tree_store.append(reslt, ['\\{p}'])
    tree_store.append(reslt, ['\\{z}'])
    tree_store.append(reslt, ['\\{t}'])
    tree_store.append(reslt, ['\\chi2'])
    tree_store.append(reslt, ['\\{F}'])
    tree_store.append(reslt, ['\\Left'])
    tree_store.append(reslt, ['\\Right'])
    tree_store.append(reslt, ['\\p^'])
    tree_store.append(reslt, ['\\p^1'])
    tree_store.append(reslt, ['\\p^2'])
    tree_store.append(reslt, ['\\df'])
    tree_store.append(reslt, ['\\{s}'])
    tree_store.append(reslt, ['\\Cor'])
    tree_store.append(reslt, ['\\r2'])
    grph = tree_store.append(item_vars, ['GRPH'])
    tree_store.append(grph, ['\\Y '])
    tree_store.append(grph, ['\\{r} '])
    tree_store.append(grph, ['\\Xt '])
    tree_store.append(grph, ['\\Yt '])
    tree_store.append(grph, ['\\{X}'])
    dyna = tree_store.append(item_vars, ['DYNA'])
    tree_store.append(dyna, ['\\D Start'])
    tree_store.append(dyna, ['\\D End'])
    tree_store.append(dyna, ['\\D pitch'])
    tabl = tree_store.append(item_vars, ['TABL'])
    tree_store.append(tabl, ['\\F Start'])
    tree_store.append(tabl, ['\\F End'])
    tree_store.append(tabl, ['\\F pitch'])
    tree_store.append(tabl, ['\\F Result'])
    recr = tree_store.append(item_vars, ['RECR'])
    form = tree_store.append(recr, ['FORM'])
    tree_store.append(form, ["a\\R n"])
    tree_store.append(form, ["a\\R n+"])
    tree_store.append(form, ["a\\R n+2"])
    tree_store.append(form, ["b\\R n"])
    tree_store.append(form, ["b\\R n+"])
    tree_store.append(form, ["b\\R n+2"])
    rang = tree_store.append(recr, ['RANG'])
    tree_store.append(rang, ["\\R Start"])
    tree_store.append(rang, ["\\R End"])
    tree_store.append(rang, ["\\a0"])
    tree_store.append(rang, ['\\a1'])
    tree_store.append(rang, ['\\a2'])
    tree_store.append(rang, ['\\b0'])
    tree_store.append(rang, ['\\b1'])
    tree_store.append(rang, ['\\b2'])
    tree_store.append(rang, ['a\\R nStart'])
    tree_store.append(rang, ['b\\R nStart'])
    tree_store.append(recr, ['\\R Result'])
    equa = tree_store.append(item_vars, ['EQUA'])
    tree_store.append(equa, ['\\Sim Result'])
    tree_store.append(equa, ['\\Sim Coef'])
    tree_store.append(equa, ['\\Ply Result'])
    tree_store.append(equa, ['\\Ply Coef'])
    tvm = tree_store.append(item_vars, ['TVM'])
    tree_store.append(tvm, ['\\{n}'])
    tree_store.append(tvm, ['\\I%'])
    tree_store.append(tvm, ['\\PV'])
    tree_store.append(tvm, ['\\PMT'])
    tree_store.append(tvm, ['\\FV'])
    tree_store.append(tvm, ['\\P/Y'])
    tree_store.append(tvm, ['\\C/Y'])
    # prgm
    prgm = tree_store.append(None, ['[PRGM]'])
    com = tree_store.append(prgm, ['COM'])
    tree_store.append(com, ['\\If '])
    tree_store.append(com, ['\\Then '])
    tree_store.append(com, ['\\Else '])
    tree_store.append(com, ['\\IfEnd'])
    tree_store.append(com, ['\\For '])
    tree_store.append(com, ['\\ To '])
    tree_store.append(com, ['\\ Step '])
    tree_store.append(com, ['\\Next'])
    tree_store.append(com, ['\\While '])
    tree_store.append(com, ['\\WhileEnd'])
    tree_store.append(com, ['\\Do'])
    tree_store.append(com, ['\\LpWhile '])
    ctl = tree_store.append(prgm, ['CTL'])
    tree_store.append(ctl, ['\\Prog '])
    tree_store.append(ctl, ['\\Return'])
    tree_store.append(ctl, ['\\Break'])
    tree_store.append(ctl, ['\\Stop'])
    jump = tree_store.append(prgm, ['JUMP'])
    tree_store.append(jump, ['\\Lbl '])
    tree_store.append(jump, ['\\Goto '])
    tree_store.append(jump, ['\\=>'])
    tree_store.append(jump, ['\\Isz '])
    tree_store.append(jump, ['\\Dsz '])
    tree_store.append(prgm, ['?'])
    tree_store.append(prgm, ['\\Disp\n'])
    clr = tree_store.append(prgm, ['CLR'])
    tree_store.append(clr, ['\\ClrText'])
    tree_store.append(clr, ['\\ClrGraph'])
    tree_store.append(clr, ['\\ClrList'])
    disp = tree_store.append(prgm, ['DISP'])
    tree_store.append(disp, ['\\DrawStat'])
    tree_store.append(disp, ['\\DrawGraph'])
    tree_store.append(disp, ['\\DrawDyna'])
    ftbl = tree_store.append(disp, ['F-Tbl'])
    tree_store.append(ftbl, ['\\DispF-Tbl'])
    tree_store.append(ftbl, ['\\DrawFTG-Con'])
    tree_store.append(ftbl, ['\\DrawFTG-Plt'])
    rtbl = tree_store.append(disp, ['R-Tbl'])
    tree_store.append(rtbl, ['\\DispR-Tbl'])
    tree_store.append(rtbl, ['\\DrawWeb '])
    tree_store.append(rtbl, ['\\DrawR-Con'])
    tree_store.append(rtbl, ['\\DrawR-SumCon'])
    tree_store.append(rtbl, ['\\DrawR-Plt'])
    tree_store.append(rtbl, ['\\DrawR-SumPlt'])
    rel = tree_store.append(prgm, ['REL'])
    tree_store.append(rel, ['='])
    tree_store.append(rel, ['<>'])
    tree_store.append(rel, ['>'])
    tree_store.append(rel, ['<'])
    tree_store.append(rel, ['>='])
    tree_store.append(rel, ['<='])
    item_io = tree_store.append(prgm, ['I/O'])
    tree_store.append(item_io, ['\\Locate '])
    tree_store.append(item_io, ['\\Getkey'])
    tree_store.append(item_io, ['\\Send('])
    tree_store.append(item_io, ['\\Receive('])
    tree_store.append(prgm, [':'])
    setup = tree_store.append(None, ['[SET UP]'])
    angl = tree_store.append(setup, ['ANGL'])
    tree_store.append(angl, ['\\Deg'])
    tree_store.append(angl, ['\\Rad'])
    tree_store.append(angl, ['\\Gra'])
    coor = tree_store.append(setup, ['COOR'])
    tree_store.append(coor, ['\\CoordOn'])
    tree_store.append(coor, ['\\CoordOff'])
    grid = tree_store.append(setup, ['GRID'])
    tree_store.append(grid, ['\\GridOn'])
    tree_store.append(grid, ['\\GridOff'])
    axes = tree_store.append(setup, ['AXES'])
    tree_store.append(axes, ['\\AxesOn'])
    tree_store.append(axes, ['\\AxesOff'])
    labl = tree_store.append(setup, ['LABL'])
    tree_store.append(labl, ['\\LabelOn'])
    tree_store.append(labl, ['\\LabelOff'])
    disp = tree_store.append(setup, ['DISP'])
    tree_store.append(disp, ['\\Fix '])
    tree_store.append(disp, ['\\Sci '])
    tree_store.append(disp, ['\\Norm'])
    tree_store.append(disp, ['\\Eng'])
    item_pl = tree_store.append(setup, ['P/L'])
    tree_store.append(item_pl, ['\\P/L-Blue'])
    tree_store.append(item_pl, ['\\P/L-Orange'])
    tree_store.append(item_pl, ['\\P/L-Green'])
    draw = tree_store.append(setup, ['DRAW'])
    tree_store.append(draw, ['\\G-Connect'])
    tree_store.append(draw, ['\\G-Plot'])
    derv = tree_store.append(setup, ['DERV'])
    tree_store.append(derv, ['\\DerivOn'])
    tree_store.append(derv, ['\\DerivOff'])
    back = tree_store.append(setup, ['BACK'])
    tree_store.append(back, ['\\BG-None'])
    tree_store.append(back, ['\\BG-Pict '])
    func = tree_store.append(setup, ['FUNC'])
    tree_store.append(func, ['\\FuncOn'])
    tree_store.append(func, ['\\FuncOff'])
    swin = tree_store.append(setup, ['S-WIN'])
    tree_store.append(swin, ['\\S-WindAuto'])
    tree_store.append(swin, ['\\S-WindMan'])
    item_list = tree_store.append(setup, ['LIST'])
    tree_store.append(item_list, ['\\File1'])
    tree_store.append(item_list, ['\\File2'])
    tree_store.append(item_list, ['\\File3'])
    tree_store.append(item_list, ['\\File4'])
    tree_store.append(item_list, ['\\File5'])
    tree_store.append(item_list, ['\\File6'])
    locs = tree_store.append(setup, ['LOCS'])
    tree_store.append(locs, ['\\LocusOn'])
    tree_store.append(locs, ['\\LocusOff'])
    tvar = tree_store.append(setup, ['T-VAR'])
    tree_store.append(tvar, ['\\VarRange'])
    item_list = tree_store.append(tvar, ['LIST'])
    tree_store.append(item_list, ['\\VarList1'])
    tree_store.append(item_list, ['\\VarList2'])
    tree_store.append(item_list, ['\\VarList3'])
    tree_store.append(item_list, ['\\VarList4'])
    tree_store.append(item_list, ['\\VarList5'])
    tree_store.append(item_list, ['\\VarList6'])
    sumdsp = tree_store.append(setup, ['SumDSP'])
    tree_store.append(sumdsp, ['\\SumDispOn'])
    tree_store.append(sumdsp, ['\\SumDispOff'])
    resid = tree_store.append(setup, ['RESID'])
    tree_store.append(resid, ['\\Resid-None'])
    tree_store.append(resid, ['\\Resid-List '])

    base = tree_store.append(None, ['BASE'])
    keyboard = tree_store.append(base, ['Keyboard'])
    tree_store.append(keyboard, ['\\hA'])
    tree_store.append(keyboard, ['\\hB'])
    tree_store.append(keyboard, ['\\hC'])
    tree_store.append(keyboard, ['\\hD'])
    tree_store.append(keyboard, ['\\hE'])
    tree_store.append(keyboard, ['\\hF'])
    menu = tree_store.append(base, ['MENU'])
    item_do = tree_store.append(menu, ['d~o'])
    tree_store.append(item_do, ['\\Dec>'])
    tree_store.append(item_do, ['\\Hex>'])
    tree_store.append(item_do, ['\\Bin>'])
    tree_store.append(item_do, ['\\Oct>'])
    log = tree_store.append(menu, ['LOG'])
    tree_store.append(log, ['\\Neg '])
    tree_store.append(log, ['\\ Not '])
    tree_store.append(log, ['\\and'])
    tree_store.append(log, ['\\or'])
    tree_store.append(log, ['\\xor'])
    tree_store.append(log, ['\\xnor'])
    setup = tree_store.append(base, ['[SET UP]'])
    tree_store.append(setup, ['\\Dec'])
    tree_store.append(setup, ['\\Hex'])
    tree_store.append(setup, ['\\Bin'])
    tree_store.append(setup, ['\\Oct'])
